*OLSTFP*
regress ln_sales ln_l ln_m ln_k
est store regression
gen ln_ols_e=ln_sales-_b[ln_l]*ln_l-_b[ln_m]*ln_m-_b[ln_k]*ln_k
gen ols_e=exp(ln_ols_e)
drop  _est_regression

*OPTFP*
rename ln_sales lnsales
rename ln_k lnk
rename ln_invest lninvest
rename ln_m lnm
rename ln_l lnl
opreg lnsales, exit(exit) state(lnk) proxy(lninvest) free(lnm lnl)
predict ln_op_e
gen op_e=exp(ln_op_e)

*LPTFPѡ*
levpet ln_sales, free(ln_l) proxy(ln_m) capital(ln_k) revenue
predict lp_e, omega
sum ols_e op_e lp_e
cor ols_e op_e lp_e

*ȥtfpֵ*
bysort year: egen p1_op = pctile(op_e), p(1)
bysort year: egen p99_op= pctile(op_e), p(99)
bysort year: keep if op_e>p1_op&op_e<p99_op

*ȥҵ for OP_TFP*
bysort indu: egen mean1999=mean(op_e) if year==1999
bysort indu: egen mean2000=mean(op_e) if year==2000
bysort indu: egen mean2001=mean(op_e) if year==2001
bysort indu: egen mean2002=mean(op_e) if year==2002
bysort indu: egen mean2003=mean(op_e) if year==2003
bysort indu: egen mean2004=mean(op_e) if year==2004
bysort indu: egen mean2005=mean(op_e) if year==2005
bysort indu: egen mean2006=mean(op_e) if year==2006
bysort indu: egen mean2007=mean(op_e) if year==2007
gen indu_mean=mean1999 if year==1999
replace indu_mean=mean2000 if year==2000
replace indu_mean=mean2001 if year==2001
replace indu_mean=mean2002 if year==2002
replace indu_mean=mean2003 if year==2003
replace indu_mean=mean2004 if year==2004
replace indu_mean=mean2005 if year==2005
replace indu_mean=mean2006 if year==2006
replace indu_mean=mean2007 if year==2007

*׼ TFP*
gen rtfp=log(op_e/indu_mean)

*ɷʵָ*
drop if cap_sta<0 |cap_col<0| cap_rep<0| cap_ind<0| cap_hkg<0| cap_fgn<0
gen capital2=(cap_sta+cap_col+cap_rep+cap_ind+cap_hkg+cap_fgn)
drop if capital2==0| capital2==.
gen sta_rate=cap_sta/capital2
gen col_rate=cap_col/capital2
gen rep_rate=cap_rep/capital2
gen ind_rate=cap_ind/capital2
gen fgn_rate=(cap_hkg+cap_fgn)/capital2
gen pro_rate=max(sta_rate, col_rate, rep_rate, fgn_rate, ind_rate) 
gen pro_sta=(sta_rate==pro_rate)
gen pro_col=(col_rate==pro_rate)
gen pro_ind=(ind_rate==pro_rate)
gen pro_rep=(rep_rate==pro_rate)
gen pro_fgn=(fgn_rate==pro_rate)

gen k_l=fixed_asset/worker
gen markup=sales/(sales-profit_op)
gen indu2=int(industry/10)
sort indu2 year
by indu2 year: egen t_sales=total(sales)
gen hhi0=(sales/t_sales)^2
by indu2 year: egen hhi=total(hhi0)
by indu2 year: egen t_profit=total(profit_op)
gen indu_markup=t_sales/(t_sales-t_profit)
sort indu2 year fgn_rate
gen sales2=sales if fgn_rate>0.5 
replace sales2=0 if sales2==.
by indu2 year: egen fgn_sales=total(sales2) 
by indu2 year: gen fdi=fgn_sales/t_sales
drop hhi0 t_sales sales2 t_profit

tsset id year
gen export_d=(export>0)
drop if rand<0
drop if rand>=sales & rand!=.
gen rdint=(rand/sales)
replace rdint=(l.rdint+f.rdint)/2 if year==2004
gen age=(year-openyear+1)




